/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  ჌xvZbT샋[`(SH2p)
 */


#ifndef	_CPU_INSN_H_
#define	_CPU_INSN_H_

/*
 *  Inline֐vg^Cv錾
 */
Inline void disable_int(void);
Inline void enable_int(void);
Inline void nop(void);
Inline void set_sr(UINT32 sr);
Inline UINT32 current_sr(void);


extern UINT32 lock_flag;
extern UINT32 intmask;

/*
 *  Xe[^XWX^iSRǰݒl̕ύX
 */
Inline void
set_sr(UINT32 sr)
{
	Asm("ldc %0, sr" : : "r"(sr) );
}

/*
 *  Xe[^XWX^iSRǰݒl̓Ǐo
 */
Inline UINT32
current_sr(void)
{
	UINT32 sr;
	Asm("stc  sr,%0" : "=r"(sr));
	return(sr);
}


/*
 *  OݑS֎~
 */
Inline void
disable_int(void)
{
	volatile UINT32 intmask_temp;
	
	/*
	 * Ń[JϐSRWX^̒lۑĂ̂́A
	 * SRWX^̓ǂݏoƎۂɊ݋֎~̊ԂɊ荞݂ꍇɁA
	 * 荞݃nhŊ荞݋֎~sintmaskl
	 * Ă܂߂ł
	 */
	
	intmask_temp = current_sr() & 0x000000f0u;
	set_sr((current_sr() & ~0x000000f0u) |  (MAX_IPM << 4) );
	intmask = intmask_temp;
	lock_flag = 1;
}


/*
 *  OݑS֎~
 */
Inline void
enable_int(void)
{
	lock_flag = 0;
	set_sr((current_sr() & ~0x000000f0u) | intmask);
}


/*
 *  nop ߂̎s
 */
Inline void
nop(void)
{
	asm("	nop");
}

#endif /* _CPU_INSN_H_ */
